/* System.c generated by valac 0.30.0, the Vala compiler
 * generated from System.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>


#define PLANK_SERVICES_TYPE_SYSTEM (plank_services_system_get_type ())
#define PLANK_SERVICES_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_TYPE_SYSTEM, PlankServicesSystem))
#define PLANK_SERVICES_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_TYPE_SYSTEM, PlankServicesSystemClass))
#define PLANK_SERVICES_IS_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_TYPE_SYSTEM))
#define PLANK_SERVICES_IS_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_TYPE_SYSTEM))
#define PLANK_SERVICES_SYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_TYPE_SYSTEM, PlankServicesSystemClass))

typedef struct _PlankServicesSystem PlankServicesSystem;
typedef struct _PlankServicesSystemClass PlankServicesSystemClass;
typedef struct _PlankServicesSystemPrivate PlankServicesSystemPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))

struct _PlankServicesSystem {
	GObject parent_instance;
	PlankServicesSystemPrivate * priv;
};

struct _PlankServicesSystemClass {
	GObjectClass parent_class;
};


static gpointer plank_services_system_parent_class = NULL;

GType plank_services_system_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_SYSTEM_DUMMY_PROPERTY
};
static PlankServicesSystem* plank_services_system_new (void);
static PlankServicesSystem* plank_services_system_construct (GType object_type);
void plank_services_system_open_uri (const gchar* uri);
void plank_services_system_open (GFile* file);
void plank_services_system_launch_with_files (GFile* app, GFile** files, int files_length1);
void plank_services_system_open_files (GFile** files, int files_length1);
void plank_services_system_launch (GFile* app);
static gboolean plank_services_system_path_is_mounted (const gchar* path);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static void plank_services_system_internal_launch (GFile* app, GList* files);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
gboolean plank_services_system_is_desktop_session (const gchar* session);
static const gchar* plank_services_system_get_current_desktop_session (void);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static PlankServicesSystem* plank_services_system_construct (GType object_type) {
	PlankServicesSystem * self = NULL;
	self = (PlankServicesSystem*) g_object_new (object_type, NULL);
	return self;
}


static PlankServicesSystem* plank_services_system_new (void) {
	return plank_services_system_construct (PLANK_SERVICES_TYPE_SYSTEM);
}


/**
 * Opens a file based on a URI.
 *
 * @param uri the URI to open
 */
void plank_services_system_open_uri (const gchar* uri) {
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	g_return_if_fail (uri != NULL);
	_tmp0_ = uri;
	_tmp1_ = g_file_new_for_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	plank_services_system_open (_tmp2_);
	_g_object_unref0 (_tmp2_);
}


/**
 * Opens a file based on a {@link GLib.File}.
 *
 * @param file the {@link GLib.File} to open
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void plank_services_system_open (GFile* file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile** _tmp2_ = NULL;
	GFile** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_tmp2_ = g_new0 (GFile*, 1 + 1);
	_tmp2_[0] = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 1;
	plank_services_system_launch_with_files (NULL, _tmp3_, 1);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_object_unref), NULL);
}


/**
 * Opens multiple files based on {@link GLib.File}.
 *
 * @param files the {@link GLib.File}s to open
 */
void plank_services_system_open_files (GFile** files, int files_length1) {
	GFile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	_tmp0_ = files;
	_tmp0__length1 = files_length1;
	plank_services_system_launch_with_files (NULL, _tmp0_, _tmp0__length1);
}


/**
 * Launches an application.
 *
 * @param app the application to launch
 */
void plank_services_system_launch (GFile* app) {
	GFile* _tmp0_ = NULL;
	GFile** _tmp1_ = NULL;
	GFile** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = g_new0 (GFile*, 0 + 1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = 0;
	plank_services_system_launch_with_files (_tmp0_, _tmp2_, 0);
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_object_unref), NULL);
}


/**
 * Launches an application and opens files.
 *
 * @param app the application to launch
 * @param files the files to open with the application
 */
static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


void plank_services_system_launch_with_files (GFile* app, GFile** files, int files_length1) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	GList* mounted_files = NULL;
	GFile** _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gboolean _tmp29_ = FALSE;
	GList* _tmp30_ = NULL;
	guint _tmp31_ = 0U;
	GError * _inner_error_ = NULL;
	_tmp1_ = app;
	if (_tmp1_ != NULL) {
		GFile* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		_tmp2_ = app;
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
		_tmp0_ = !_tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = app;
		_tmp6_ = g_file_get_path (_tmp5_);
		_tmp4_ = _tmp6_;
		if (_tmp4_ == NULL) {
			gchar* _tmp7_ = NULL;
			_tmp7_ = g_strdup ("");
			_g_free0 (_tmp4_);
			_tmp4_ = _tmp7_;
		}
		g_warning ("System.vala:80: Application '%s' doesn't exist", _tmp4_);
		_g_free0 (_tmp4_);
		return;
	}
	mounted_files = NULL;
	_tmp8_ = files;
	_tmp8__length1 = files_length1;
	{
		GFile** f_collection = NULL;
		gint f_collection_length1 = 0;
		gint _f_collection_size_ = 0;
		gint f_it = 0;
		f_collection = _tmp8_;
		f_collection_length1 = _tmp8__length1;
		for (f_it = 0; f_it < _tmp8__length1; f_it = f_it + 1) {
			GFile* _tmp9_ = NULL;
			GFile* f = NULL;
			_tmp9_ = _g_object_ref0 (f_collection[f_it]);
			f = _tmp9_;
			{
				gchar* path = NULL;
				GFile* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				const gchar* _tmp14_ = NULL;
				_tmp10_ = f;
				_tmp11_ = g_file_get_path (_tmp10_);
				path = _tmp11_;
				_tmp14_ = path;
				if (_tmp14_ != NULL) {
					const gchar* _tmp15_ = NULL;
					_tmp15_ = path;
					_tmp13_ = g_strcmp0 (_tmp15_, "") != 0;
				} else {
					_tmp13_ = FALSE;
				}
				if (_tmp13_) {
					gboolean _tmp16_ = FALSE;
					GFile* _tmp17_ = NULL;
					gboolean _tmp18_ = FALSE;
					_tmp17_ = f;
					_tmp18_ = g_file_is_native (_tmp17_);
					if (_tmp18_) {
						_tmp16_ = TRUE;
					} else {
						const gchar* _tmp19_ = NULL;
						gboolean _tmp20_ = FALSE;
						_tmp19_ = path;
						_tmp20_ = plank_services_system_path_is_mounted (_tmp19_);
						_tmp16_ = _tmp20_;
					}
					_tmp12_ = _tmp16_;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GFile* _tmp21_ = NULL;
					GFile* _tmp22_ = NULL;
					_tmp21_ = f;
					_tmp22_ = _g_object_ref0 (_tmp21_);
					mounted_files = g_list_append (mounted_files, _tmp22_);
					_g_free0 (path);
					_g_object_unref0 (f);
					continue;
				}
				{
					GFile* _tmp23_ = NULL;
					gchar* _tmp24_ = NULL;
					gchar* _tmp25_ = NULL;
					_tmp23_ = f;
					_tmp24_ = g_file_get_uri (_tmp23_);
					_tmp25_ = _tmp24_;
					g_app_info_launch_default_for_uri (_tmp25_, NULL, &_inner_error_);
					_g_free0 (_tmp25_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch59_g_error;
					}
				}
				goto __finally59;
				__catch59_g_error:
				{
					GFile* _tmp26_ = NULL;
					GFile* _tmp27_ = NULL;
					GFile* _tmp28_ = NULL;
					g_clear_error (&_inner_error_);
					_inner_error_ = NULL;
					_tmp26_ = f;
					g_file_mount_enclosing_volume (_tmp26_, 0, NULL, NULL, NULL, NULL);
					_tmp27_ = f;
					_tmp28_ = _g_object_ref0 (_tmp27_);
					mounted_files = g_list_append (mounted_files, _tmp28_);
				}
				__finally59:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_free0 (path);
					_g_object_unref0 (f);
					__g_list_free__g_object_unref0_0 (mounted_files);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_free0 (path);
				_g_object_unref0 (f);
			}
		}
	}
	_tmp30_ = mounted_files;
	_tmp31_ = g_list_length (_tmp30_);
	if (_tmp31_ > ((guint) 0)) {
		_tmp29_ = TRUE;
	} else {
		GFile** _tmp32_ = NULL;
		gint _tmp32__length1 = 0;
		_tmp32_ = files;
		_tmp32__length1 = files_length1;
		_tmp29_ = _tmp32__length1 == 0;
	}
	if (_tmp29_) {
		GFile* _tmp33_ = NULL;
		GList* _tmp34_ = NULL;
		_tmp33_ = app;
		_tmp34_ = mounted_files;
		plank_services_system_internal_launch (_tmp33_, _tmp34_);
	}
	__g_list_free__g_object_unref0_0 (mounted_files);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gboolean plank_services_system_path_is_mounted (const gchar* path) {
	gboolean result = FALSE;
	GVolumeMonitor* _tmp0_ = NULL;
	GVolumeMonitor* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = g_volume_monitor_get ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_volume_monitor_get_mounts (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	{
		GList* m_collection = NULL;
		GList* m_it = NULL;
		m_collection = _tmp3_;
		for (m_it = m_collection; m_it != NULL; m_it = m_it->next) {
			GMount* _tmp4_ = NULL;
			GMount* m = NULL;
			_tmp4_ = _g_object_ref0 ((GMount*) m_it->data);
			m = _tmp4_;
			{
				GFile* m_root = NULL;
				GMount* _tmp5_ = NULL;
				GFile* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				gchar* m_path = NULL;
				GFile* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_ = NULL;
				_tmp5_ = m;
				_tmp6_ = g_mount_get_root (_tmp5_);
				m_root = _tmp6_;
				_tmp7_ = m_root;
				if (_tmp7_ == NULL) {
					_g_object_unref0 (m_root);
					_g_object_unref0 (m);
					continue;
				}
				_tmp8_ = m_root;
				_tmp9_ = g_file_get_path (_tmp8_);
				m_path = _tmp9_;
				_tmp11_ = m_path;
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_ = NULL;
					const gchar* _tmp13_ = NULL;
					gboolean _tmp14_ = FALSE;
					_tmp12_ = path;
					_tmp13_ = m_path;
					_tmp14_ = string_contains (_tmp12_, _tmp13_);
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					result = TRUE;
					_g_free0 (m_path);
					_g_object_unref0 (m_root);
					_g_object_unref0 (m);
					__g_list_free__g_object_unref0_0 (m_collection);
					return result;
				}
				_g_free0 (m_path);
				_g_object_unref0 (m_root);
				_g_object_unref0 (m);
			}
		}
		__g_list_free__g_object_unref0_0 (m_collection);
	}
	result = FALSE;
	return result;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static void plank_services_system_internal_launch (GFile* app, GList* files) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	GAppInfo* info = NULL;
	GFile* _tmp4_ = NULL;
	GAppInfo* _tmp38_ = NULL;
	GError * _inner_error_ = NULL;
	_tmp1_ = app;
	if (_tmp1_ == NULL) {
		GList* _tmp2_ = NULL;
		guint _tmp3_ = 0U;
		_tmp2_ = files;
		_tmp3_ = g_list_length (_tmp2_);
		_tmp0_ = _tmp3_ == ((guint) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	info = NULL;
	_tmp4_ = app;
	if (_tmp4_ != NULL) {
		GKeyFile* keyfile = NULL;
		gchar* launcher = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GKeyFile* _tmp28_ = NULL;
		GDesktopAppInfo* _tmp29_ = NULL;
		_tmp5_ = app;
		_tmp6_ = g_file_get_path (_tmp5_);
		launcher = _tmp6_;
		{
			GKeyFile* _tmp7_ = NULL;
			GKeyFile* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			_tmp7_ = g_key_file_new ();
			_g_key_file_unref0 (keyfile);
			keyfile = _tmp7_;
			_tmp8_ = keyfile;
			_tmp9_ = launcher;
			g_key_file_load_from_file (_tmp8_, _tmp9_, G_KEY_FILE_NONE, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch60_g_error;
			}
		}
		goto __finally60;
		__catch60_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp10_ = NULL;
			GError* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp10_ = launcher;
			_tmp11_ = e;
			_tmp12_ = _tmp11_->message;
			g_critical ("System.vala:136: %s: %s", _tmp10_, _tmp12_);
			_g_error_free0 (e);
			_g_free0 (launcher);
			_g_key_file_unref0 (keyfile);
			_g_object_unref0 (info);
			return;
		}
		__finally60:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (launcher);
			_g_key_file_unref0 (keyfile);
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		{
			gchar* type = NULL;
			GKeyFile* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			GQuark _tmp18_ = 0U;
			_tmp13_ = keyfile;
			_tmp14_ = g_key_file_get_string (_tmp13_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, &_inner_error_);
			type = _tmp14_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_KEY_FILE_ERROR) {
					goto __catch61_g_key_file_error;
				}
				_g_free0 (launcher);
				_g_key_file_unref0 (keyfile);
				_g_object_unref0 (info);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp15_ = type;
			_tmp16_ = _tmp15_;
			_tmp18_ = (NULL == _tmp16_) ? 0 : g_quark_from_string (_tmp16_);
			if (_tmp18_ == g_quark_from_string (G_KEY_FILE_DESKTOP_TYPE_LINK)) {
				switch (0) {
					default:
					{
						{
							gchar* url = NULL;
							GKeyFile* _tmp19_ = NULL;
							gchar* _tmp20_ = NULL;
							const gchar* _tmp21_ = NULL;
							_tmp19_ = keyfile;
							_tmp20_ = g_key_file_get_string (_tmp19_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_URL, &_inner_error_);
							url = _tmp20_;
							if (G_UNLIKELY (_inner_error_ != NULL)) {
								goto __catch62_g_error;
							}
							_tmp21_ = url;
							g_app_info_launch_default_for_uri (_tmp21_, NULL, &_inner_error_);
							if (G_UNLIKELY (_inner_error_ != NULL)) {
								_g_free0 (url);
								goto __catch62_g_error;
							}
							_g_free0 (url);
						}
						goto __finally62;
						__catch62_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp22_ = NULL;
							GError* _tmp23_ = NULL;
							const gchar* _tmp24_ = NULL;
							e = _inner_error_;
							_inner_error_ = NULL;
							_tmp22_ = launcher;
							_tmp23_ = e;
							_tmp24_ = _tmp23_->message;
							g_critical ("System.vala:152: %s: %s", _tmp22_, _tmp24_);
							_g_error_free0 (e);
						}
						__finally62:
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							_g_free0 (type);
							if (_inner_error_->domain == G_KEY_FILE_ERROR) {
								goto __catch61_g_key_file_error;
							}
							_g_free0 (type);
							_g_free0 (launcher);
							_g_key_file_unref0 (keyfile);
							_g_object_unref0 (info);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
						_g_free0 (type);
						_g_free0 (launcher);
						_g_key_file_unref0 (keyfile);
						_g_object_unref0 (info);
						return;
					}
				}
			} else {
				switch (0) {
					default:
					{
						break;
					}
				}
			}
			_g_free0 (type);
		}
		goto __finally61;
		__catch61_g_key_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp25_ = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp25_ = launcher;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			g_critical ("System.vala:157: %s: %s", _tmp25_, _tmp27_);
			_g_error_free0 (e);
			_g_free0 (launcher);
			_g_key_file_unref0 (keyfile);
			_g_object_unref0 (info);
			return;
		}
		__finally61:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (launcher);
			_g_key_file_unref0 (keyfile);
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp28_ = keyfile;
		_tmp29_ = g_desktop_app_info_new_from_keyfile (_tmp28_);
		_g_object_unref0 (info);
		info = (GAppInfo*) _tmp29_;
		_g_free0 (launcher);
		_g_key_file_unref0 (keyfile);
	} else {
		{
			GAppInfo* _tmp30_ = NULL;
			GList* _tmp31_ = NULL;
			GList* _tmp32_ = NULL;
			gconstpointer _tmp33_ = NULL;
			GAppInfo* _tmp34_ = NULL;
			GAppInfo* _tmp35_ = NULL;
			_tmp31_ = files;
			_tmp32_ = g_list_first (_tmp31_);
			_tmp33_ = _tmp32_->data;
			_tmp34_ = g_file_query_default_handler ((GFile*) _tmp33_, NULL, &_inner_error_);
			_tmp30_ = _tmp34_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch63_g_error;
			}
			_tmp35_ = _tmp30_;
			_tmp30_ = NULL;
			_g_object_unref0 (info);
			info = _tmp35_;
			_g_object_unref0 (_tmp30_);
		}
		goto __finally63;
		__catch63_g_error:
		{
			GError* e = NULL;
			GError* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp36_ = e;
			_tmp37_ = _tmp36_->message;
			g_critical ("System.vala:166: %s", _tmp37_);
			_g_error_free0 (e);
		}
		__finally63:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp38_ = info;
	if (_tmp38_ == NULL) {
		gchar* _tmp39_ = NULL;
		GFile* _tmp40_ = NULL;
		_tmp40_ = app;
		if (_tmp40_ != NULL) {
			GFile* _tmp41_ = NULL;
			gchar* _tmp42_ = NULL;
			_tmp41_ = app;
			_tmp42_ = g_file_get_path (_tmp41_);
			_g_free0 (_tmp39_);
			_tmp39_ = _tmp42_;
		} else {
			GList* _tmp43_ = NULL;
			GList* _tmp44_ = NULL;
			gconstpointer _tmp45_ = NULL;
			gchar* _tmp46_ = NULL;
			_tmp43_ = files;
			_tmp44_ = g_list_first (_tmp43_);
			_tmp45_ = _tmp44_->data;
			_tmp46_ = g_file_get_path ((GFile*) _tmp45_);
			_g_free0 (_tmp39_);
			_tmp39_ = _tmp46_;
		}
		g_critical ("System.vala:171: Unable to use application/file '%s' for execution.", _tmp39_);
		_g_free0 (_tmp39_);
		_g_object_unref0 (info);
		return;
	}
	{
		GList* _tmp47_ = NULL;
		guint _tmp48_ = 0U;
		GAppInfo* _tmp50_ = NULL;
		gboolean _tmp51_ = FALSE;
		GAppInfo* _tmp54_ = NULL;
		gboolean _tmp55_ = FALSE;
		GAppInfo* _tmp62_ = NULL;
		const gchar* _tmp63_ = NULL;
		_tmp47_ = files;
		_tmp48_ = g_list_length (_tmp47_);
		if (_tmp48_ == ((guint) 0)) {
			GAppInfo* _tmp49_ = NULL;
			_tmp49_ = info;
			g_app_info_launch (_tmp49_, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch64_g_error;
			}
			_g_object_unref0 (info);
			return;
		}
		_tmp50_ = info;
		_tmp51_ = g_app_info_supports_files (_tmp50_);
		if (_tmp51_) {
			GAppInfo* _tmp52_ = NULL;
			GList* _tmp53_ = NULL;
			_tmp52_ = info;
			_tmp53_ = files;
			g_app_info_launch (_tmp52_, _tmp53_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch64_g_error;
			}
			_g_object_unref0 (info);
			return;
		}
		_tmp54_ = info;
		_tmp55_ = g_app_info_supports_uris (_tmp54_);
		if (_tmp55_) {
			GList* uris = NULL;
			GList* _tmp56_ = NULL;
			GAppInfo* _tmp60_ = NULL;
			GList* _tmp61_ = NULL;
			uris = NULL;
			_tmp56_ = files;
			{
				GList* f_collection = NULL;
				GList* f_it = NULL;
				f_collection = _tmp56_;
				for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
					GFile* _tmp57_ = NULL;
					GFile* f = NULL;
					_tmp57_ = _g_object_ref0 ((GFile*) f_it->data);
					f = _tmp57_;
					{
						GFile* _tmp58_ = NULL;
						gchar* _tmp59_ = NULL;
						_tmp58_ = f;
						_tmp59_ = g_file_get_uri (_tmp58_);
						uris = g_list_append (uris, _tmp59_);
						_g_object_unref0 (f);
					}
				}
			}
			_tmp60_ = info;
			_tmp61_ = uris;
			g_app_info_launch_uris (_tmp60_, _tmp61_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				__g_list_free__g_free0_0 (uris);
				goto __catch64_g_error;
			}
			__g_list_free__g_free0_0 (uris);
			_g_object_unref0 (info);
			return;
		}
		_tmp62_ = info;
		_tmp63_ = g_app_info_get_name (_tmp62_);
		g_warning ("System.vala:195: The application '%s' doesn't support files/URIs or wa" \
"sn't found.", _tmp63_);
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		GError* _tmp64_ = NULL;
		const gchar* _tmp65_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp64_ = e;
		_tmp65_ = _tmp64_->message;
		g_critical ("System.vala:197: %s", _tmp65_);
		_g_error_free0 (e);
	}
	__finally64:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (info);
}


gboolean plank_services_system_is_desktop_session (const gchar* session) {
	gboolean result = FALSE;
	const gchar* current_session = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	g_return_val_if_fail (session != NULL, FALSE);
	_tmp0_ = plank_services_system_get_current_desktop_session ();
	current_session = _tmp0_;
	_tmp1_ = current_session;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp2_ = current_session;
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
	_tmp4_ = _tmp3_;
	_tmp5_ = session;
	_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strcmp0 (_tmp4_, _tmp7_) == 0;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	result = _tmp8_;
	return result;
}


static const gchar* plank_services_system_get_current_desktop_session (void) {
	const gchar* result = NULL;
	const gchar* current_session = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp3_ = NULL;
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
	current_session = _tmp0_;
	_tmp1_ = current_session;
	if (_tmp1_ == NULL) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = g_getenv ("DESKTOP_SESSION");
		current_session = _tmp2_;
	}
	_tmp3_ = current_session;
	result = _tmp3_;
	return result;
}


static void plank_services_system_class_init (PlankServicesSystemClass * klass) {
	plank_services_system_parent_class = g_type_class_peek_parent (klass);
}


static void plank_services_system_instance_init (PlankServicesSystem * self) {
}


/**
 * A utility class for launching applications and opening files/URIs.
 */
GType plank_services_system_get_type (void) {
	static volatile gsize plank_services_system_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_system_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesSystemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_system_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesSystem), 0, (GInstanceInitFunc) plank_services_system_instance_init, NULL };
		GType plank_services_system_type_id;
		plank_services_system_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesSystem", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_system_type_id__volatile, plank_services_system_type_id);
	}
	return plank_services_system_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



