/* Version.c generated by valac 0.30.0, the Vala compiler
 * generated from Version.vala, do not modify */

/**/
/*  Copyright (C) 2014 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include "config.h"
#include <stdlib.h>
#include <string.h>




#define PLANK_VERSION_MAJOR 0
#define PLANK_VERSION_MINOR 10
#define PLANK_VERSION_MICRO 1
#define PLANK_VERSION_NANO 0
guint plank_version_get_major_version (void);
guint plank_version_get_minor_version (void);
guint plank_version_get_micro_version (void);
guint plank_version_get_nano_version (void);
const gchar* plank_version_check (guint required_major, guint required_minor, guint required_micro);


/**
 * Returns the major version number of the plank library.
 *
 * This function is in the library, so it represents the GTK+
 * library your code is are running against.
 *
 * @return the major version number of the plank library
 */
guint plank_version_get_major_version (void) {
	guint result = 0U;
	result = VERSION_MAJOR;
	return result;
}


/**
 * Returns the minor version number of the plank library.
 *
 * This function is in the library, so it represents the plank
 * library your code is are running against.
 *
 * @return the minor version number of the plank library
 */
guint plank_version_get_minor_version (void) {
	guint result = 0U;
	result = VERSION_MINOR;
	return result;
}


/**
 * Returns the micro version number of the plank library.
 *
 * This function is in the library, so it represents the plank
 * library your code is are running against.
 *
 * @return the micro version number of the plank library
 */
guint plank_version_get_micro_version (void) {
	guint result = 0U;
	result = VERSION_MICRO;
	return result;
}


/**
 * Returns the nano version number of the plank library.
 *
 * This function is in the library, so it represents the plank
 * library your code is are running against.
 *
 * @return the nano version number of the plank library
 */
guint plank_version_get_nano_version (void) {
	guint result = 0U;
	result = VERSION_NANO;
	return result;
}


/**
 * Checks that the plank library in use is compatible with the given version.
 *
 * This function is in the library, so it represents the plank
 * library your code is are running against.
 *
 * @param required_major the required major version
 * @param required_minor the required minor version
 * @param required_micro the required micro version
 * @return null if the plank library is compatible with the given version,
 * or a string describing the version mismatch.
 */
const gchar* plank_version_check (guint required_major, guint required_minor, guint required_micro) {
	const gchar* result = NULL;
	guint effective_micro = 0U;
	guint required_effective_micro = 0U;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	guint _tmp4_ = 0U;
	effective_micro = (100 * VERSION_MINOR) + VERSION_MICRO;
	_tmp0_ = required_minor;
	_tmp1_ = required_micro;
	required_effective_micro = (100 * _tmp0_) + _tmp1_;
	_tmp2_ = required_major;
	if (_tmp2_ > VERSION_MAJOR) {
		result = "plank version too old (major mismatch)";
		return result;
	}
	_tmp3_ = required_effective_micro;
	_tmp4_ = effective_micro;
	if (_tmp3_ > _tmp4_) {
		result = "plank version too old (micro mismatch)";
		return result;
	}
	result = NULL;
	return result;
}



